rename_modal = {

    height: 270,

    done_callback : function(target) {
        var name = $("#rename-modal-name").val().trim();
        if (name === "") {
            showError("ERROR", "ERROR: Volume name cannot be empty");
            return;
        }
        data = {name: name};
        operations.perform_operation(target, sources.operations.rename, data);
    },

    popup : function(event) {
        readiness.with_provisioning_enabled(function() {
            var target = $(event.target);
            var actions = target.closest('.actions');
            var selInfinibox = target.closest('.infinibox.root');
            var system_serial = selInfinibox.data('serial');
            view.blockElement(selInfinibox, true);
            auth.call_with_credentials(system_serial,
                function() {
                    $("#rename-modal #vol-name").text(actions.data("name"));
                    $("#rename-modal-name").val(actions.data("name"));
                    $("#rename-modal-name").regexRestrict(RegExp("[^a-zA-Z0-9\\+\\^&\'@{}\\$=!()#%.~_ -]", "g"));
                    $("#rename-modal").dialog({
                        modal: true,
                        width: 540,
                        height: rename_modal.height,
                        resizable: false,
                        open: function() {
                            $("#rename-modal-name").select().focus();
                        },
                        buttons: [
                            {
                                text: "OK",
                                click: function(event) {
                                    $(this).dialog("close");
                                    rename_modal.done_callback(target);
                                }
                            },
                            {
                                text: "CANCEL",
                                click: function() {
                                    $(this).dialog("close");
                                }
                            }
                        ]
                    });
                },
                function() {
                    view.blockElement(selInfinibox, false);
                }
            );
        });
    }

}