resize_modal = {

    popup : function(event, size_check_function) {
        readiness.with_provisioning_enabled(function() {
            var target = $(event.target);
            var actions = target.closest('.actions');
            var selInfinibox = target.closest('.infinibox.root');
            var system_serial = selInfinibox.data('serial');
            spinnerFactory.block(selInfinibox, "small");
            auth.call_with_credentials(system_serial,
                function() {
                    $("#resize-modal #vol-name").text(actions.data("name"));
                    $("#resize-modal #current-size").text(create_vol_modal.format_size(actions.data("size")));
                    $("#resize-modal-size-text").val("").regexRestrict(RegExp("[^0-9.]", "g"));
                    $("#resize-modal").dialog({
                        modal: true,
                        width: 540,
                        height: 300,
                        resizable: false,
                        buttons: [
                            {
                                text: "OK",
                                click: function(event) {
                                    var size = $("#resize-modal-size-text").val().trim();
                                    var units = $("#resize-modal-size-unit").val()
                                    if (!size || isNaN(size)) {
                                        showError("ERROR", "ERROR: Volume size is invalid");
                                        return;
                                    }
                                    if (size_check_function) {
                                        if (!size_check_function(actions.data("size"), size, units)) {
                                            return;
                                        }
                                    }
                                    size = size + units;
                                    $(this).dialog("close");
                                    resize_modal.show_actions(actions.data("device"), size, target);
                                }
                            },
                            {
                                text: "CANCEL",
                                click: function() {
                                    $(this).dialog("close");
                                }
                            }
                        ]
                    });
                },
                function() {
                    selInfinibox.unblock();
                }
            );
        });
    },

    show_actions: function(device_name, size, target) {
        var data = {device_name: device_name, size: size};
        actions_modal.show("RESIZE VOLUME STEPS",
                           "Volume resize failed",
                           true,
                           sources.operations.get_resize_tasks,
                           sources.operations.run_resize_task,
                           data,
                           function() {operations.reload_parent_table(target)},
                           null);
   }

}