from .....case import FixableCase

#pylint: disable=R0904,W0201

class SoftwareDependency(FixableCase):
    def __init__(self, category, kb_number, package_name, package_manager_class):
        super(SoftwareDependency, self).__init__(category)
        self._kb_number = kb_number
        self._package_name = package_name
        self._package_manager_class = package_manager_class

    def run_test(self):
        self._package_manager = self.get_package_manager()
        self.assertTrue(self._package_manager.is_package_installed(self.get_package_name()),
                        "package {} is not installed".format(self.get_package_name()))

    def get_fix_description(self):
        return "install missing package {} using the system package manager".format(self.get_package_name())

    def run_fix(self):
        self._package_manager.install_package(self.get_package_name())

    def get_description(self):
        return "Checking that {} is installed".format(self.get_package_name())

    def get_kb_number(self):
        return self._kb_number

    def get_package_name(self):
        return self._package_name

    def get_package_manager(self):
        return self._package_manager_class()
